﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using RocketDivision.StarBurnX;
using System.Threading;

namespace StarBurnTestDebugError
{
    public partial class Form1 : Form
    {
        StarBurnX m_StarBurn = new StarBurnX();

        public Form1()
        {
            InitializeComponent();
            
            m_StarBurn.InitializeEx("...", STARBURN_TRANSPORT.STARBURN_TRANSPORT_SPTI);
            m_StarBurn.Refresh();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            Drive drive = m_StarBurn.Drives[1];
            for (int i = 0; i < 1000; i++)
            {
                ThreadPool.QueueUserWorkItem(Refresh, drive);
                ThreadPool.QueueUserWorkItem(Refresh, drive);
                ThreadPool.QueueUserWorkItem(Refresh, drive);

                Application.DoEvents();
                Thread.Sleep(100);
            }
        }

        private void Refresh(object x)
        {
            ((Drive)x).DiscInfo.Refresh();

            this.BeginInvoke((ParameterizedThreadStart)AfterRefresh, x);
        }

        private void AfterRefresh(object x)
        {
            string discType = ((Drive)x).DiscInfo.DiscType.ToString();
            Application.DoEvents();
            string used = ((Drive)x).DiscInfo.UsedSize.ToString();
            Application.DoEvents();
            string status = ((Drive)x).DiscInfo.Status.ToString();
            Application.DoEvents();
            string total = ((Drive)x).DiscInfo.TotalSize.ToString();
            Application.DoEvents();

            label1.Text = discType + used + status + total;
        }
    }
}
